MPD 0.20.6

- Main Page
- Namespaces
- Data Structures
- Files

- File List
- Globals

PcmMix.hxx
Go to the documentation of this file.
1 /*
2 * Copyright 2003-2017 The Music Player Daemon Project
3 * http://www.musicpd.org
4 *
5 * This program is free software; you can redistribute it and/or modify
6 * it under the terms of the GNU General Public License as published by
7 * the Free Software Foundation; either version 2 of the License, or
8 * (at your option) any later version.
9 *
10 * This program is distributed in the hope that it will be useful,
11 * but WITHOUT ANY WARRANTY; without even the implied warranty of
12 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 * GNU General Public License for more details.
14 *
15 * You should have received a copy of the GNU General Public License along
16 * with this program; if not, write to the Free Software Foundation, Inc.,
17 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
18 */
19
20 #ifndef MPD_PCM_MIX_HXX
21 #define MPD_PCM_MIX_HXX
22
23 #include "SampleFormat.hxx"
24 #include "Compiler.h"
25
26 #include <stddef.h>
27
28 class PcmDither;
29
30 /*
31 * Linearly mixes two PCM buffers. Both must have the same length and
32 * the same audio format. The formula is:
33 *
34 * s1 := s1 * portion1 + s2 * (1 - portion1)
35 *
36 * @param buffer1 the first PCM buffer, and the destination buffer
37 * @param buffer2 the second PCM buffer
38 * @param size the size of both buffers in bytes
39 * @param format the sample format of both buffers
40 * @param portion1 a number between 0.0 and 1.0 specifying the portion
41 * of the first buffer in the mix; portion2 = (1.0 - portion1).
42 * Negative values are used by the MixRamp code to specify that simple
43 * addition is required.
44 *
45 * @return true on success, false if the format is not supported
46 */
47 gcc_warn_unused_result
48 bool
49 pcm_mix(PcmDither &dither, void *buffer1, const void *buffer2, size_t size,
50 SampleFormat format, float portion1);
51
52 #endif
pcm_mix
gcc_warn_unused_result bool pcm_mix(PcmDither &dither, void *buffer1, const void *buffer2, size_t size, SampleFormat format, float portion1)
Compiler.h
SampleFormat
SampleFormat
Definition: SampleFormat.hxx:33
SampleFormat.hxx
gcc_warn_unused_result
#define gcc_warn_unused_result
Definition: Compiler.h:119
PcmDither
Definition: PcmDither.hxx:27